GPU-LS(1)

NAME
gpu-ls - display details about compatible GPU cards

SYNOPSIS
gpu-ls [--short | --long | --raw | --table]
gpu-ls [--pstates | --ppm | --features | --clinfo]
gpu-ls [--no_markup] [--force_all] [--verbose] [--no_fan] [--debug]
gpu-ls [--help | --about]

DESCRIPTION
gpu-ls displays most relevant parameters for installed and compatible GPUs. The default behavior is to list relevant parameters by GPU. OpenCL platform information is added when the --clinfo option is used. A brief listing of key parameters is available with the --short command line option. A simplified table of current GPU state is displayed with the --table option. The --no_fan can be used to ignore fan settings. The --pstate option can be used to output the p-state table for each GPU instead of the list of basic parameters. The --ppm option is used to output the table of available power/performance modes instead of basic parameters. The --features option is used to output the table of amdgpu pp features and their status instead of basic parameters. The --force_all option will result in the attempt read of all of the sensors defined in rickslab-gpu-utils. The --raw option will attempt to read all possible driver files and display a lightly formatted version of the results. Finally, the --verbose option will result in informational messages to be displayed. By default, output data is formatted and color coded, so the --no_markup option can be specified to get plain text.

OPTIONS

--about
    Will display details about gpu-ls.

--short
    Will display short list of key descriptive parameters for each installed GPU.

--long
    Will display long list of descriptive parameters and all of output for ppm, pstate, features, and clinfo reports for each installed GPU.

--table
    Will display table of basic GPU parameters.

--raw
    Will display a summary from the reading of all driver files, evening those not used by rickslab-gpu-utils. The output will indicate which sensors are used and the contents of all driver files that are readable.

--ppm
    Will display descriptions of available power performance modes.

--pstates
    Will display P-state table for system and memory clocks.

--features
    Will display PP Features table that gives details of driver feature status.

--clinfo
    If the clinfo package is installed, openCL details will be included in the output for each compatible GPU.

--no_fan
    Will exclude fan information from the display. Useful with water cooled GPUs.

--no_markup
    Outputs plain text instead of color formatted text.

--force_all
    Forces the read of all configured sensors and includes a summary of sensors that could not be read.

--verbose
    Display informational messages generated during execution.

--debug
    Will output additional useful debug/troubleshooting details to a log file.

-h, --help
    Display help text and exit.

EXAMPLES
gpu-ls

This will display the basic parameters for all compatible GPUs. These include device ID, GPU frequency/voltage control type, decoded device ID, card model, short card model, display card model, card number, card path, PCIe ID, driver, vBIOS version, HWmon path, current power, power cap, power cap range, fan enable, fan PWM mode, current fan PWM, current fan speed, fan target speed, fan speed range, fan PWM range, current temp, critical temp, current VddGF, Vddc range, current GPU loading, memory details, link speed, link width, current Sclk p-state, current Sclk frequency, Sclk range, current Mclk p-state, current Mclk frequency, Mclk range, power performance mode, and power force performance level.

gpu-ls --short --verbose

This will produce a short list of key descriptive parameters for each installed GPU. Informational messages on utility execution will be displayed before the GPU summary output.

gpu-ls --clinfo

In addition to the basic parameters, openCL parameters are also displayed for each compatible GPU. This option is dependent on the installation of clinfo.

gpu-ls --ppm

Instead of the basic parameters, a table of power/performance modes is displayed.

gpu-ls --pstates

Instead of the basic parameters, a table of power states or curve points is displayed.

gpu-ls --raw

This option will probe all possible driver files and display a summary that shows the results of reading the files. If the driver file used by the utility, then the utility keyword and description will be included in the output colored green. Details read from each file are displayed in cyan.

CONFIGURATION
In order to get maximum capability of these utilities, you should be running with a kernel that provides support of the GPUs you have installed. If using AMD GPUs, installing the latest amdgpu driver package or the latest ROCm release, may provide additional capabilities. If you have Nvidia GPUs installed, nvidia-smi must also be installed in order for the utility reading of the cards to be possible. Writing to GPUs is currently only possible for AMD GPUs, and only with compatible cards and with the AMD ppfeaturemask set to 0xfffd7fff. This can be accomplished by adding amdgpu.ppfeaturemask=0xfffd7fff to the GRUB_CMDLINE_LINUX_DEFAULT value in /etc/default/grub and executing sudo update-grub.

FILES

/usr/share/misc/pci.ids
    The system list of all known PCI ID's (vendors, devices, classes and subclasses). It can be updated with the update-pciids command.

/sys/class/drm/card*/device/pp_od_clk_voltage
    Special driver file for each AMD GPU required by some rickslab-gpu-utils.

/etc/default/grub
    The grub defaults file where amdgpu.ppfeaturemask needs to be set.

BUGS
Known to not work well with Fiji ProDuo cards and will issue warning messages for Fiji Nano cards. Please report any additional bugs/issues at https://github.com/Ricks-Lab/gpu-utils

SEE ALSO
clinfo(1), amdgpu(4), nvidia-smi(1), update-grub(8), update-pciids(8), lspci(8)

AVAILABILITY
The gpu-ls command is part of the rickslab-gpu-utils package and is available from https://github.com/Ricks-Lab/gpu-utils